using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserContract;
namespace CMSMicroservice.Protobuf.Validator.UserContract;

public class DeleteUserContractRequestValidator : AbstractValidator<DeleteUserContractRequest>
{
    public DeleteUserContractRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<DeleteUserContractRequest>.CreateWithOptions((DeleteUserContractRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
